<?php

/**
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @package clearFusionCMS\module\hipchat
 * @copyright Copyright (c) 2013 clearFusionCMS. All rights reserved.
 * @link http://clearfusioncms.com
 */

/**
 * hipchatEvents Class
 *
 * Class to process HipChat module events.
 *
 * @package clearFusionCMS\module\hipchat
 */
class hipchatEvents {

	/**
	 * Event handler for system notify updates.
	 *
	 * @param flEvent $evt The event object.
	 */
	function onNotify($evt) {
		$cfg = clearFusionCMS::getSiteConfig('cfHipChat');

		if(!empty($cfg->token) && !empty($cfg->room) && ($level = $evt->getParam('level', 1)) >= $cfg->level) {
			$colorMap = array(1 => 'gray', 2 => 'purple', 3 => 'green', 4 => 'yellow', 5 => 'red' );
			$level = min(max($level, 1), 5);

			$mention = trim($evt->getParam('mention', ''));
			if(!empty($mention))
				$mention = $mention . ' ';

			$client = new flHttpClient('https://api.hipchat.com/v1/rooms/message');
			$client->setPostData(array(
				'auth_token' => $cfg->token,
				'room_id' => $cfg->room,
				'from' => utf8_encode($cfg->get('from', 'CMS')),
				'message' => utf8_encode(substr($mention . $evt->getParam('message', '') . ($cfg->incSite ? "\n - " . clearFusionCMS::getSiteName() : ''), 0, 10000)),
				'notify' => $level >= $cfg->notify ? '1' : '0',
				'color' => $colorMap[$level],
				'message_format' => 'text',
				'format' => 'json'
			));

			$client->sendRequest();
		}
	}
}
